package com.order.controller.notify;

import com.alibaba.fastjson.JSONObject;
import com.hfkj.common.utils.HttpsUtils;
import com.hfkj.config.CommonSysConst;
import com.hfkj.jd.JdService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.PrintWriter;

@Controller
@RequestMapping(value = "/jdNotify")
@Api(value = "京东回调")
public class JdNotify {
    private static final Logger log = LoggerFactory.getLogger(JdService.class);

    @RequestMapping(value = "/notify", method = RequestMethod.POST)
    @ApiOperation(value = "回调")
    @ResponseBody
    public void notify(@RequestBody String reqBodyStr, HttpServletRequest request, HttpServletResponse response) {
        try {

            JSONObject dataObject = JSONObject.parseObject(reqBodyStr, JSONObject.class);

            log.info("============回调任务Start=============");
            log.info("尖椒订单充值-回调参数: " + dataObject);
            log.info("============回调任务End=============");


            response.setCharacterEncoding("UTF-8");
            response.setContentType("text/html;charset=utf-8");
            PrintWriter writer= response.getWriter();
            writer.write("SUCCESS");


        } catch (Exception e) {
            log.error("WechatPayController --> wechatNotify() error!", e);
        }
    }

    @RequestMapping(value = "/callbackToken", method = RequestMethod.GET)
    @ApiOperation(value = "token回调")
    @ResponseBody
    public void notify(@RequestParam("code") String code) {
        try {

            log.info("============token回调任务Start=============");
            log.info("token回调-回调参数: " + code);
            JSONObject object = new JSONObject();
            object.put("app_key", CommonSysConst.getSysConfig().getJDAppKey());
            object.put("app_secret", CommonSysConst.getSysConfig().getJDAppSecret());
            object.put("code", code);
            object.put("grant_type", "authorization_code");
            JSONObject jsonObject = HttpsUtils.doGet("https://open-oauth.jd.com/oauth2/authorizeForVOP", object);
            log.info("token回调-回调参数: " + jsonObject);
            log.info("============token回调任务End=============");

        } catch (Exception e) {
            log.error("WechatPayController --> wechatNotify() error!", e);
        }
    }
}
