package com.hfkj.model.excel;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 订单退款记录
 * @className: OrderAfterSalesApplyModel
 * @author: HuRui
 * @date: 2024/9/19
 **/
@Data
public class OrderRefundModel {

    @ColumnWidth(25)
    @ExcelProperty("退款单号")
    private String refundOrderNo;

    @ColumnWidth(25)
    @ExcelProperty("交易单号")
    private String orderNo;

    @ColumnWidth(20)
    @ExcelProperty("商品单号")
    private String orderChildNo;

    @ColumnWidth(20)
    @ExcelProperty("用户手机号")
    private String userPhone;

    @ColumnWidth(20)
    @ExcelProperty("支付渠道")
    private String refundPayChannel;

    @ColumnWidth(20)
    @ExcelProperty("支付方式")
    private String refundPayType;

    @ColumnWidth(20)
    @ExcelProperty("退款金额")
    private BigDecimal refundPrice;

    @ColumnWidth(20)
    @ExcelProperty("退款积分")
    private Long refundIntegral;

    @ColumnWidth(20)
    @ExcelProperty("创建时间")
    private Date createTime;

    @ColumnWidth(20)
    @ExcelProperty("退款时间")
    private Date refundTime;

    @ColumnWidth(20)
    @ExcelProperty("状态")
    private String status;

}
