package com.hfkj.model.order.orderExport;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
  * @ClassName MerOrderSettlementDetailModel
  * @Author Sum1Dream
  * @Description 商户订单结算详情
  * @Date 2024/9/29 上午10:50
 **/
@Data
public class MerOrderSettlementDetailModel {

    @ColumnWidth(50)
    @ExcelProperty("商品名称")
    public String goodsName;

    @ColumnWidth(20)
    @ExcelProperty("商户名称")
    public String merName;

    @ColumnWidth(20)
    @ExcelProperty("业务类型")
    public String businessType;

    @ColumnWidth(20)
    @ExcelProperty("登录平台")
    public String platform;

    @ColumnWidth(40)
    @ExcelProperty("订单号")
    public String orderNo;

    @ColumnWidth(15)
    @ExcelProperty("子订单号")
    public String childOrderNo;

    @ColumnWidth(20)
    @ExcelProperty("业务信息")
    public String business;

    @ColumnWidth(20)
    @ExcelProperty({"支付金额"})
    public BigDecimal payRealPrice;

    @ColumnWidth(20)
    @ExcelProperty({"支付方式"})
    public String payType;

    @ColumnWidth(20)
    @ExcelProperty("收货时间")
    public String finishTime;
}
