package com.hfkj.service.goods;

import com.hfkj.entity.BsOrderMeituan;

import java.util.List;
import java.util.Map;

public interface BsOrderMeiTuanService {

    /**
     * @MethodName create
     * @Description: 创建
     * @param orderMeiTuan
     * @Author: Sum1Dream
     * @Date: 2024/9/5 下午4:18
     */
    void create(BsOrderMeituan orderMeiTuan);

    /**
     * @MethodName update
     * @Description: 更新
     * @param orderMeiTuan
     * @Author: Sum1Dream
     * @Date: 2024/9/5 下午4:19
     */
    void update(BsOrderMeituan orderMeiTuan);

    /**
     * @MethodName delete
     * @Description: 删除
     * @param id
     * @param fullDelete
     * @Author: Sum1Dream
     * @Date: 2024/9/5 下午4:19
     */
    void delete(Long id , Boolean fullDelete);

    /**
     * @MethodName queryDetail
     * @Description: 查询详情
     * @param id
     * @return: com.hfkj.entity.BsOrderMeituan
     * @Author: Sum1Dream
     * @Date: 2024/9/5 下午4:19
     */
    BsOrderMeituan queryDetail(Long id);

    /**
     * @MethodName findOrderMeiTuan
     * @Description: 根据订单号查询
     * @param childOrderNo
     * @return: com.hfkj.entity.BsOrderMeituan
     * @Author: Sum1Dream
     * @Date: 2024/9/5 下午4:22
     */
    BsOrderMeituan findOrderMeiTuan(String childOrderNo);

    /**
     * @MethodName findOrderMeiTuanByTradeNo
     * @Description: 通过渠道订单号查询
     * @param tradeNo
     * @return: com.hfkj.entity.BsOrderMeituan
     * @Author: Sum1Dream
     * @Date: 2024/9/18 下午5:54
     */
    BsOrderMeituan findOrderMeiTuanByTradeNo(String tradeNo);

    /**
     * @MethodName findOrderMeiTuanBySqtBizOrderId
     * @Description:
     * @param sqtBizOrderId 
 * @return: com.hfkj.entity.BsOrderMeituan
     * @Author: Sum1Dream
     * @Date: 2024/9/26 下午3:39
     */
    BsOrderMeituan findOrderMeiTuanBySqtBizOrderId(String sqtBizOrderId);

    /**
     * @MethodName getOrderList
     * @Description: 查询美团订单
     * @param map
     * @return: java.util.List<com.hfkj.entity.BsOrderMeituan>
     * @Author: Sum1Dream
     * @Date: 2024/9/26 下午1:45
     */
    List<BsOrderMeituan> getOrderList(Map<String , Object> map);
    /**
     * @MethodName getOrderListFinish
     * @Description:
     * @param map
     * @return: java.util.List<com.hfkj.entity.BsOrderMeituan>
     * @Author: Sum1Dream
     * @Date: 2024/9/29 下午4:34
     */
    List<BsOrderMeituan> getOrderListFinish(Map<String , Object> map);

    void orderFinish(String childNo);

}
