package com.hfkj.service.goods;


import com.hfkj.entity.BsOrderMember;

import java.util.List;
import java.util.Map;

public interface BsOrderMemberService {

    /**
     * @MethodName create
     * @Description: 创建
     * @param orderMember
     * @Author: Sum1Dream
     * @Date: 2024/9/5 下午4:18
     */
    void create(BsOrderMember orderMember);

    /**
     * @MethodName update
     * @Description: 更新
     * @param orderMember
     * @Author: Sum1Dream
     * @Date: 2024/9/5 下午4:19
     */
    void update(BsOrderMember orderMember);

    /**
     * @MethodName delete
     * @Description: 删除
     * @param id
     * @param fullDelete
     * @Author: Sum1Dream
     * @Date: 2024/9/5 下午4:19
     */
    void delete(Long id , Boolean fullDelete);

    /**
     * @MethodName queryDetail
     * @Description: 查询详情
     * @param id
     * @return: com.hfkj.entity.BsOrderMember
     * @Author: Sum1Dream
     * @Date: 2024/9/5 下午4:19
     */
    BsOrderMember queryDetail(Long id);

    /**
     * @MethodName findGoodsOrder
     * @Description: 根据订单号查询
     * @param orderNo
     * @return: com.hfkj.entity.BsOrderMember
     * @Author: Sum1Dream
     * @Date: 2024/9/5 下午4:22
     */
    BsOrderMember findGoodsOrder(String orderNo);
    /**
     * @MethodName findGoodsOrderByChildNo
     * @Description: 根据子订单号查询
     * @param childNo
     * @return: com.hfkj.entity.BsOrderMember
     * @Author: Sum1Dream
     * @Date: 2024/9/25 上午10:50
     */
    BsOrderMember findGoodsOrderByChildNo(String childNo);

    /**
     * @MethodName queryDetailByMap
     * @Description: 查询订单详情
     * @param map
     * @return: com.hfkj.entity.BsOrderMember
     * @Author: Sum1Dream
     * @Date: 2024/9/5 下午4:27
     */
    BsOrderMember queryDetailByMap(Map<String , Object> map);

    /**
     * @MethodName getList
     * @Description: 查询订单列表
     * @param map
     * @return: java.util.List<com.hfkj.entity.BsOrderMember>
     * @Author: Sum1Dream
     * @Date: 2024/9/5 下午4:27
     */
    List<BsOrderMember> getList(Map<String , Object> map);
    /**
     * @MethodName getListFinish
     * @Description:
     * @param map
     * @return: java.util.List<com.hfkj.entity.BsOrderMember>
     * @Author: Sum1Dream
     * @Date: 2024/9/29 下午4:38
     */
    List<BsOrderMember> getListFinish(Map<String , Object> map);
}
