package com.hfkj.service.goods.impl;

import com.alibaba.fastjson.JSONObject;
import com.hfkj.common.utils.DateUtil;
import com.hfkj.config.CommonSysConst;
import com.hfkj.dao.BsOrderMeituanMapper;
import com.hfkj.entity.BsOrderMeituan;
import com.hfkj.entity.BsOrderMeituanExample;
import com.hfkj.meituan.MeiTuanService;
import com.hfkj.service.goods.BsOrderMeiTuanService;
import com.hfkj.service.order.BsOrderService;
import com.hfkj.sysenum.order.OrderChildStatusEnum;
import org.apache.commons.collections4.MapUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.*;

@Service("bsOrderMeiTuanService")
public class BsOrderMeiTuanServiceImpl implements BsOrderMeiTuanService {

    @Resource
    private BsOrderMeituanMapper bsOrderMeituanMapper;

    @Resource
    private BsOrderService orderService;

    @Override
    public void create(BsOrderMeituan orderMeiTuan) {
        bsOrderMeituanMapper.insert(orderMeiTuan);
    }

    @Override
    public void update(BsOrderMeituan orderMeiTuan) {
        bsOrderMeituanMapper.updateByPrimaryKeySelective(orderMeiTuan);
    }

    @Override
    public void delete(Long id, Boolean fullDelete) {

    }

    @Override
    public BsOrderMeituan queryDetail(Long id) {
        return null;
    }

    @Override
    public BsOrderMeituan findOrderMeiTuan(String childOrderNo) {
        BsOrderMeituanExample example = new BsOrderMeituanExample();
        BsOrderMeituanExample.Criteria criteria = example.createCriteria();
        criteria.andChildOrderNoEqualTo(childOrderNo);

        List<BsOrderMeituan> list = bsOrderMeituanMapper.selectByExample(example);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    @Override
    public BsOrderMeituan findOrderMeiTuanByTradeNo(String tradeNo) {
        BsOrderMeituanExample example = new BsOrderMeituanExample();
        BsOrderMeituanExample.Criteria criteria = example.createCriteria();
        criteria.andTradeNoEqualTo(tradeNo);

        List<BsOrderMeituan> list = bsOrderMeituanMapper.selectByExample(example);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    @Override
    public BsOrderMeituan findOrderMeiTuanBySqtBizOrderId(String sqtBizOrderId) {
        BsOrderMeituanExample example = new BsOrderMeituanExample();
        BsOrderMeituanExample.Criteria criteria = example.createCriteria();
        criteria.andSqtBizOrderIdEqualTo(sqtBizOrderId);

        List<BsOrderMeituan> list = bsOrderMeituanMapper.selectByExample(example);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    @Override
    public List<BsOrderMeituan> getOrderList(Map<String, Object> map) {
        BsOrderMeituanExample example = new BsOrderMeituanExample();
        BsOrderMeituanExample.Criteria criteria = example.createCriteria();

        if (StringUtils.isNotBlank(MapUtils.getString(map, "orderNo"))) {
            criteria.andOrderNoEqualTo(MapUtils.getString(map, "orderNo"));
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "childOrderNo"))) {
            criteria.andChildOrderNoEqualTo(MapUtils.getString(map, "childOrderNo"));
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "tradeNo"))) {
            criteria.andChildOrderNoEqualTo(MapUtils.getString(map, "tradeNo"));
        }

        if (StringUtils.isNotBlank(MapUtils.getString(map, "userPhone"))) {
            criteria.andUserPhoneEqualTo(MapUtils.getString(map, "userPhone"));
        }

        if (StringUtils.isNotBlank(MapUtils.getString(map, "goodsName"))) {
            criteria.andGoodsNameLike("%"+MapUtils.getString(map, "goodsName")+"%");
        }

        if (MapUtils.getInteger(map, "payType") != null) {
            criteria.andPayTypeEqualTo(MapUtils.getInteger(map, "payType"));
        }
        if (MapUtils.getLong(map, "createTimeS") != null) {
            criteria.andCreateTimeGreaterThanOrEqualTo(new Date(MapUtils.getLong(map, "createTimeS")));
        }
        if (MapUtils.getLong(map, "createTimeE") != null) {
            criteria.andCreateTimeLessThan(new Date(MapUtils.getLong(map, "createTimeE")));
        }
        if (MapUtils.getLong(map, "finishTimeS") != null) {
            criteria.andFinishTimeGreaterThanOrEqualTo(new Date(MapUtils.getLong(map, "finishTimeS")));
        }
        if (MapUtils.getLong(map, "finishTimeE") != null) {
            criteria.andFinishTimeLessThan(new Date(MapUtils.getLong(map, "finishTimeE")));
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status"));
        }
        example.setOrderByClause("create_time desc");
        return bsOrderMeituanMapper.selectByExample(example);
    }

    @Override
    public List<BsOrderMeituan> getOrderListFinish(Map<String, Object> map) {

        BsOrderMeituanExample example = new BsOrderMeituanExample();
        BsOrderMeituanExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getLong(map, "finishTimeS") != null) {
            criteria.andFinishTimeGreaterThanOrEqualTo(new Date(MapUtils.getLong(map, "finishTimeS")));
        }
        if (MapUtils.getLong(map, "finishTimeE") != null) {
            criteria.andFinishTimeLessThan(new Date(MapUtils.getLong(map, "finishTimeE")));
        }
        if (MapUtils.getLong(map, "merId") != null) {
            criteria.andMerIdEqualTo(MapUtils.getLong(map, "merId"));
        }
        if (MapUtils.getInteger(map, "payType") != null) {
            criteria.andPayTypeEqualTo(MapUtils.getInteger(map, "payType"));
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "platform"))) {
            criteria.andPlatformCodeEqualTo(MapUtils.getString(map, "platform"));
        }
        criteria.andStatusEqualTo(3);
        return bsOrderMeituanMapper.selectByExample(example);
    }

    @Override
    public void orderFinish(String childNo) {

        BsOrderMeituan orderMeiTuan = findOrderMeiTuan(childNo);

        if (orderMeiTuan != null) {
            // 查询上游订单状态
            Map<String , Object> map = new HashMap<>();
            map.put("ts" , new Date().getTime());
            map.put("entId" , CommonSysConst.getSysConfig().getEntId());
            map.put("sqtBizOrderId" , orderMeiTuan.getSqtBizOrderId());
            JSONObject object = MeiTuanService.queryDetail(map);
            Boolean finish = false;
            Date finshDate = new Date();

            if (object != null) {
                // 订单基本信息
                JSONObject baseInfo = object.getJSONObject("baseInfo");
                // 	业务信息字段
                JSONObject orderInfo = JSONObject.parseObject(object.getString("origOrderInfo"));
                // 判断业务类型
                // 到店
                if (baseInfo.getString("firstBusinessType").equals("010")) {
                    // 判断是否完成
                    if (orderInfo.getInteger("groupConsumeStatus") == 10) {
                        finish = true;
                    }

                }
                // 外卖
                if (baseInfo.getString("firstBusinessType").equals("020")) {
                    // 判断是否完成
                    if (orderInfo.getInteger("orderStatus") == 8) {
                        finish = true;
                        finshDate = DateUtil.StringToDate(orderInfo.getString("deliverTime") , "yyyy-MM-dd HH:mm:ss");
                    }
                }

                if (finish) {
                    // 子订单完成
                    orderService.childOrderComplete(childNo);
                    orderMeiTuan.setFinishTime(finshDate);
                    orderMeiTuan.setUpdateTime(new Date());
                    orderMeiTuan.setStatus(OrderChildStatusEnum.status3.getCode());
                    update(orderMeiTuan);
                }

            }
        }


    }
}
