package com.hfkj.service.goods.impl;

import com.hfkj.dao.BsOrderMemberMapper;
import com.hfkj.entity.BsOrderGoodsExample;
import com.hfkj.entity.BsOrderMember;
import com.hfkj.entity.BsOrderMemberExample;
import com.hfkj.service.goods.BsOrderMemberService;
import org.apache.commons.collections4.MapUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("bsOrderMemberService")
public class BsOrderMemberServiceImpl implements BsOrderMemberService {

    @Resource
    private BsOrderMemberMapper bsOrderMemberMapper;

    @Override
    public void create(BsOrderMember orderMember) {
        bsOrderMemberMapper.insert(orderMember);
    }

    @Override
    public void update(BsOrderMember orderMember) {
        bsOrderMemberMapper.updateByPrimaryKey(orderMember);
    }

    @Override
    public void delete(Long id, Boolean fullDelete) {
        bsOrderMemberMapper.deleteByPrimaryKey(id);
    }

    @Override
    public BsOrderMember queryDetail(Long id) {
        return bsOrderMemberMapper.selectByPrimaryKey(id);
    }

    @Override
    public BsOrderMember findGoodsOrder(String orderNo) {
        return null;
    }

    @Override
    public BsOrderMember findGoodsOrderByChildNo(String childNo) {
        BsOrderMemberExample example = new BsOrderMemberExample();
        example.createCriteria().andChildOrderNoEqualTo(childNo);

        List<BsOrderMember> list = bsOrderMemberMapper.selectByExample(example);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    @Override
    public BsOrderMember queryDetailByMap(Map<String, Object> map) {
        return null;
    }

    @Override
    public List<BsOrderMember> getList(Map<String, Object> map) {

        return Collections.emptyList();
    }

    @Override
    public List<BsOrderMember> getListFinish(Map<String, Object> map) {
        BsOrderMemberExample example = new BsOrderMemberExample();
        BsOrderMemberExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getLong(map, "finishTimeS") != null) {
            criteria.andFinishTimeGreaterThanOrEqualTo(new Date(MapUtils.getLong(map, "finishTimeS")));
        }
        if (MapUtils.getLong(map, "finishTimeE") != null) {
            criteria.andFinishTimeLessThan(new Date(MapUtils.getLong(map, "finishTimeE")));
        }
        if (MapUtils.getLong(map, "merId") != null) {
            criteria.andMerIdEqualTo(MapUtils.getLong(map, "merId"));
        }
        if (MapUtils.getInteger(map, "payType") != null) {
            criteria.andPayTypeEqualTo(MapUtils.getInteger(map, "payType"));
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "platform"))) {
            criteria.andPlatformCodeEqualTo(MapUtils.getString(map, "platform"));
        }
        criteria.andStatusEqualTo(3);
        return bsOrderMemberMapper.selectByExample(example);
    }
}
