package com.hfkj.service.order;

import com.hfkj.model.order.orderExport.MerOrderSettlementDetailModel;
import com.hfkj.model.order.orderExport.OrderSettlementModel;
import com.hfkj.model.order.orderExport.OrderSettlementSumModel;

import java.util.List;
import java.util.Map;

/**
  * @ClassName OrderSettlementService
  * @Author Sum1Dream
  * @Description 订单结算
  * @Date 2024/9/29 下午4:12
 **/
public interface OrderSettlementService {

    /**
     * @MethodName getDetail
     * @Description: 获取结算订单详情
     * @param map
     * @return: java.util.List<com.hfkj.model.order.orderExport.MerOrderSettlementDetailModel>
     * @Author: Sum1Dream
     * @Date: 2024/9/29 下午4:14
     */
    List<MerOrderSettlementDetailModel> getDetail(Map<String,Object> map);

    /**
     * @MethodName getSettlement
     * @Description: 结算订单
     * @param map
     * @return: java.util.List<com.hfkj.model.order.orderExport.OrderSettlementModel>
     * @Author: Sum1Dream
     * @Date: 2024/9/29 下午4:14
     */
    List<OrderSettlementModel> getSettlement(Map<String,Object> map);

    /**
     * @MethodName getSum
     * @Description: 结算总和
     * @param map
     * @return: java.util.List<com.hfkj.model.order.orderExport.OrderSettlementSumModel>
     * @Author: Sum1Dream
     * @Date: 2024/9/29 下午4:14
     */
    List<OrderSettlementSumModel> getSum(Map<String,Object> map);
}
